class DataPoint:
	"""A class that represent a data point"""

	"""
	Init expects a list of parameter names and a list of parameters
	"""
	def __init__(self, parameter_names, parameters):
		if (type(parameter_names) is list and type(parameters) is list):
			self.parameters = parameters
			self.parameter_names = parameter_names
			self.classification = "unknown"
		else:
			print "Wrong parameters provided"

	"""
	Create the string representation of DataPoint
	"""
	def __str__(self):
		i = 0
		text = ""

		while (i < len(self.parameter_names)):
			text += self.parameter_names[i] + " = " + self.parameters[i] + "\n"
			i += 1

		return text

	"""
	Get the parameter names that this DataPoint has
	"""
	def getParameterNames(self):
		return self.parameter_names
		
	"""
	Return the value of a given parameter name
	"""
	def getValueOfParameter(self, parameter_name):
		index = self.parameter_names.index(parameter_name)

		if (index == -1):
			print "parameter name not found"
			return None
		else:
			return self.parameters[index]

	"""
	Returns the distance between another DataPoint, without the first parameter which is the date
	"""
	def getDistance(self, dp):
		if (isinstance(dp, DataPoint)):
			d = 0
			for parameter in self.parameter_names:
				if (parameter != "Date"):
					d += pow(self.getValueOfParameter(parameter) - dp.getValueOfParameter(parameter), 2)

			return pow(d, 0.5)

		else:
			print "Argument class should be DataPoint"
			return None

	"""
	Return the date of this DataPoint
	"""
	def getDate(self):
		return self.getValueOfParameter("Date")
